defmodule Pain.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    children = [
      PainWeb.Telemetry,
      # Pain.Repo,
      {Phoenix.PubSub, name: Pain.PubSub},
      {Finch, name: Pain.Finch},
      # { Plug.Cowboy, scheme: :http, plug: PainWeb.Endpoint },
      PainWeb.Endpoint,
      {NodeJS.Supervisor, [path: LiveReact.SSR.NodeJS.server_path(), pool_size: 4]},

      # {Pain.Worker, arg}
      {AirTable.Base,
        ~w[ AIRTABLE_BASE AIRTABLE_KEY ]
        |> Enum.map(&System.get_env/1)
        |> List.to_tuple
      }
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: Pain.Supervisor]
    Supervisor.start_link(children, opts)
  end

  # Tell Phoenix to update the endpoint configuration
  # whenever the application is updated.
  @impl true
  def config_change(changed, _new, removed) do
    PainWeb.Endpoint.config_change(changed, removed)
    :ok
  end
end
